var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var WebSocketClientCommand;
(function (WebSocketClientCommand) {
    var WebSocketClient = (function (_super) {
        __extends(WebSocketClient, _super);
        function WebSocketClient() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        WebSocketClient.prototype.execute = function () {
            this.ExecuteWebSocketClient(this.CommandParam);
        };
        WebSocketClient.prototype.ExecuteWebSocketClient = function (param) {
            var runTimePageName = this.CommandExecutingInfo.runTimePageName;
            var pageName = Forguncy.ForguncyData.pageInfo.pageName;
            var protocol = this.evaluateFormula(param.Protocol);
            var socket = null;
            if (protocol === null) {
                socket = new WebSocket(param.URL);
            }
            else {
                socket = new WebSocket(param.URL, protocol);
            }
            socket.onmessage = function (event) {
                if (pageName !== Forguncy.ForguncyData.pageInfo.pageName) {
                    socket.close();
                }
                var params = {};
                params[param.SaveDataToParameter] = event.data;
                Forguncy.ForguncyData.commandExecutor.executeCommand(param.CommandList, {
                    runTimePageName: runTimePageName,
                    commandTrigger: null,
                    commandID: "87A5EE5D-B65C-4BD8-91D3-95FE0A0691E2",
                    eventType: "NotificationCommand",
                    initParams: params,
                    locationString: "WebSocketClientCommand"
                });
            };
        };
        return WebSocketClient;
    }(Forguncy.Plugin.CommandBase));
    WebSocketClientCommand.WebSocketClient = WebSocketClient;
    Forguncy.Plugin.CommandFactory.registerCommand("WebSocketClientCommand.WebSocketClientCommand, WebSocketClientCommand", WebSocketClientCommand.WebSocketClient);
})(WebSocketClientCommand || (WebSocketClientCommand = {}));
